--==============================================================================
-- 	      CÓDIGO VHDL PARA DESPLIEGUE VGA EN DE-10 LITE 							        --
-- 					  M.I. BRYAN EMMANUEL ALVAREZ SERNA									              --
-- =============================================================================

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY vga IS
PORT(RST: IN STD_LOGIC;
	  CLK: IN STD_LOGIC; -- RELOJ DE 25 MHz (PLL)    
	  VIDEO: OUT STD_LOGIC; -- SINCRONIZACION HORIZONTAL Y VERTICAL
	  HPOS: BUFFER INTEGER RANGE 0 TO 799;
	  VPOS: BUFFER INTEGER RANGE 0 TO 524;
	  HSYNC, VSYNC: out STD_LOGIC); -- SALIDAS V y H
END vga;

ARCHITECTURE BEAS OF vga IS
-- VALORES PARA MONITOR DE 640X480
CONSTANT HD: INTEGER := 639; -- PANTALLA HORIZONTAL (640)
CONSTANT VD: INTEGER := 479; -- PANTALLA VERTICAL (480)

CONSTANT HFP: INTEGER := 16; -- BORDE DERECHO (FRONT PORCH)
CONSTANT HSP: INTEGER := 96; -- SINCRONIZACION
CONSTANT HBP: INTEGER := 48; -- BORDE IZQUIERDO (BACK PORCH)

CONSTANT VFP: INTEGER := 10; -- BORDE DERECHO (FRONT PORCH)
CONSTANT VSP: INTEGER := 2; --  SINCRONIZACION
CONSTANT VBP: INTEGER := 33; -- BORDE IZQUIERDO (BACK PORCH)

--SIGNAL HPOS: INTEGER := 0; -- BARRIDO HORIZONTAL
--SIGNAL VPOS: INTEGER := 0; --  BARRIDO VERTICAL

--SIGNAL VIDEO: STD_LOGIC := '0'; -- ACTIVAION DE SALIDA DE VIDEO

BEGIN

	PROCESS(CLK, RST) -- CONTADOR HORIZONTAL
	BEGIN
		IF RST = '1' THEN
			HPOS <= 0;
			ELSIF RISING_EDGE (CLK) THEN
				IF HPOS = (HD + HFP + HSP + HBP) THEN
					HPOS <= 0;
				ELSE
					HPOS <= HPOS + 1;
				END IF;
			END IF;
	END PROCESS;

	PROCESS(CLK, RST, HPOS) -- CONTADOR VERTICAL
	BEGIN
		IF RST = '1' THEN
			VPOS <= 0;
			ELSIF RISING_EDGE (CLK) THEN
				IF HPOS = (HD + HFP + HSP + HBP) THEN
					IF VPOS = (VD + VFP + VSP + VBP) THEN
						VPOS <= 0;
					ELSE
						VPOS <= VPOS + 1;
					END IF;
				END IF;
			END IF;
	END PROCESS;

	PROCESS(CLK, RST, HPOS) -- SINCRONIZACION HORIZONTAL
	BEGIN
		IF RST = '1' THEN
			HSYNC <= '0';
		ELSIF FALLING_EDGE(CLK) THEN
			IF HPOS <= (HD + HFP) OR HPOS > (HD + HFP + HSP) THEN
				HSYNC <= '1';
			ELSE
				HSYNC <= '0';
			END IF;
		END IF;
	END PROCESS;

	PROCESS(CLK, RST, VPOS) -- SINCRONIZACION VERTICAL
	BEGIN
		IF RST = '1' THEN
			VSYNC <= '0';
		ELSIF FALLING_EDGE(CLK) THEN
			IF VPOS <= (VD + VFP) OR VPOS > (VD + VFP + VSP) THEN
				VSYNC <= '1';
			ELSE
				VSYNC <= '0';
			END IF;
		END IF;
	END PROCESS;

	PROCESS(CLK, RST, HPOS, VPOS) -- SALIDA DE VIDEO
	BEGIN
		IF RST = '1' THEN
			VIDEO <= '0';
		ELSIF FALLING_EDGE(CLK) THEN
			IF HPOS <= HD AND VPOS <= VD THEN
				VIDEO <= '1';
			ELSE
				VIDEO <= '0';
			END IF;
		END IF;
	END PROCESS;


END BEAS;
